package cn.jx.wechat.app.wechatrobot.config;


import org.springframework.boot.autoconfigure.AutoConfigurationImportFilter;
import org.springframework.boot.autoconfigure.AutoConfigurationMetadata;
import org.springframework.context.EnvironmentAware;
import org.springframework.core.env.Environment;

import java.util.*;


//@Configuration
public class AutoBeanFilterConfig implements AutoConfigurationImportFilter, EnvironmentAware {

    private Environment environment;
    private Map<String, List<String>> filterConfigMap = new LinkedHashMap<>();

    public AutoBeanFilterConfig(){
        List<String> autoPulsarFilter=new ArrayList<>(1);
        autoPulsarFilter.add("org.springframework.boot.autoconfigure.pulsar.PulsarAutoConfiguration");
        this.filterConfigMap.put("auto.Pulsar",autoPulsarFilter);
    }

    @Override
    public void setEnvironment(Environment environment) {
        this.environment = environment;
    }

    @Override
    public boolean[] match(String[] autoConfigurationClasses, AutoConfigurationMetadata autoConfigurationMetadata) {

        boolean[] skip = new boolean[autoConfigurationClasses.length];
        List<String> filterClass = new ArrayList<>(10);
        this.filterConfigMap.values().forEach(filterClass::addAll);
        if(!filterClass.isEmpty()){
            for (int i = 0; i < autoConfigurationClasses.length; i++) {
                String autoConfigurationClass = autoConfigurationClasses[i];
                if (null!=autoConfigurationClass&&
                        filterClass.stream().anyMatch(e->e.equals(autoConfigurationClass))) {
                    skip[i] = false;
                }else{
                    skip[i] = true;
                }
            }
        }else{
            for (int i = 0; i < autoConfigurationClasses.length; i++) {
                skip[i] = true;
            }
        }

        return skip;

    }
}


