package cn.jx.wechat.app.wechatrobot.config;


import org.apache.pulsar.client.api.PulsarClient;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.pulsar.core.*;
import org.springframework.pulsar.transaction.PulsarTransactionManager;


@Configuration
public class PulsarMsgQueConfig {

    @Bean("systemPulsarClientFactory")
    public DefaultPulsarClientFactory pulsarClientFactory() {
        return new DefaultPulsarClientFactory(clientBuilder -> {
            clientBuilder.serviceUrl("pulsar://127.0.0.1:6650");
        });
    }

    @Bean("systemPulsarClient")
    public PulsarClient pulsarClient(@Qualifier("systemPulsarClientFactory") PulsarClientFactory clientFactory) {
        return clientFactory.createClient();
    }




//
//    @Bean("systemPulsarProducerFactory")
//    public DefaultPulsarProducerFactory<?> pulsarProducerFactory(PulsarClient pulsarClient) {
//        DefaultPulsarProducerFactory<?> producerFactory = new DefaultPulsarProducerFactory(pulsarClient,"", topicResolver);
//        return producerFactory;
//    }





    @Bean("systemPulsarTransactionManager")
    public PulsarTransactionManager pulsarTransactionManager(@Qualifier("systemPulsarClient") PulsarClient pulsarClient) {
        return new PulsarTransactionManager(pulsarClient);
    }

}
