package cn.jx.wechat.app.wechatrobot.config;


import org.apache.hc.client5.http.impl.classic.CloseableHttpClient;
import org.apache.hc.client5.http.impl.classic.HttpClientBuilder;
import org.apache.hc.client5.http.impl.io.PoolingHttpClientConnectionManagerBuilder;
import org.apache.hc.client5.http.io.HttpClientConnectionManager;
import org.apache.hc.client5.http.ssl.*;
import org.apache.hc.core5.ssl.SSLContexts;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.autoconfigure.AutoConfiguration;
import org.springframework.boot.autoconfigure.AutoConfigureAfter;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.boot.autoconfigure.web.client.RestTemplateAutoConfiguration;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.client.ClientHttpRequestFactory;
import org.springframework.http.client.HttpComponentsClientHttpRequestFactory;
import org.springframework.web.client.RestTemplate;

import javax.net.ssl.SSLContext;




@Configuration
public class RestfulConfig {

    private static Logger log=LoggerFactory.getLogger(RestfulConfig.class);

    //默认RestTemplate配置工厂(采用httpclient5)
    @Bean("defaultAppRestFactory")
    public ClientHttpRequestFactory defaultAppRestFactory() {
        HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();


        //设置SSL,支持https协议
        SSLContext sslContext=null;
        TlsSocketStrategy tlsSocketStrategy=null;
        HttpClientConnectionManager connectionManager =null;
        try {
            sslContext = SSLContexts.custom()
                    .loadTrustMaterial(null, new TrustAllStrategy()).build();
        }catch (Exception e){
            //ignore
        }
       if(sslContext!=null){
           tlsSocketStrategy=new DefaultClientTlsStrategy(sslContext);
       }
       try {
           connectionManager = null != tlsSocketStrategy ?
                   PoolingHttpClientConnectionManagerBuilder
                           .create().setTlsSocketStrategy(tlsSocketStrategy)
                           .build() : PoolingHttpClientConnectionManagerBuilder
                   .create().build();
           httpClientBuilder.setConnectionManager(connectionManager);
       }catch (Exception e){
           //ignore
       }

        CloseableHttpClient client = httpClientBuilder.build();
        return new HttpComponentsClientHttpRequestFactory(client);

    }




    @Bean("defaultAppRest")
    public RestTemplate defaultAppRest(@Qualifier("defaultAppRestFactory") ClientHttpRequestFactory  factory) {
        return new RestTemplate(factory);
    }

}
