package cn.jx.wechat.app.wechatrobot.config;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.task.ThreadPoolTaskSchedulerBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.concurrent.CustomizableThreadFactory;
import org.springframework.scheduling.concurrent.ThreadPoolTaskScheduler;

@Configuration
public class SystemScheduleTaskConfig {


    private static Logger log = LoggerFactory.getLogger(SystemScheduleTaskConfig.class);

    private static final String  EXECUTOR_BUSINESS_NAME_PREFIX="business-executor-";

    private final int corePoolSize =50;


    @Bean(name="businessScheduler")
    public ThreadPoolTaskScheduler businessScheduler(){
        CustomizableThreadFactory customizableThreadFactory = new CustomizableThreadFactory();
        customizableThreadFactory.setDaemon(true);
        customizableThreadFactory.setThreadNamePrefix(EXECUTOR_BUSINESS_NAME_PREFIX);
        return  new ThreadPoolTaskSchedulerBuilder()
                .poolSize(corePoolSize)
                .customizers(
                        taskScheduler -> taskScheduler.setThreadFactory(customizableThreadFactory)
                )
                .build();

    }

}
