package cn.jx.wechat.app.wechatrobot.service.faceInst;

import cn.jx.wechat.app.wechatrobot.config.BusinessVerifyProperties;
import cn.jx.wechat.app.wechatrobot.service.face.BusinessVerify;
import cn.jx.wechat.app.wechatrobot.util.SpringBeanHelper;
import cn.jx.wechat.app.wechatrobot.util.WXBizMsgCrypt;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import java.net.URLDecoder;
import java.nio.charset.Charset;


public class BusinessVerifyInst implements BusinessVerify {
   private static Logger log = LoggerFactory.getLogger(BusinessVerifyInst.class);


    @Override
    public String businessCheck(String msg_signature, String timestamp, String nonce, String echostr) {
        //给企业微信验证的解密验证内容标识
        String sEchoStr;
        String  charsetEncodingName="";
        Charset charSet= Charset.defaultCharset();
        try {
            RequestAttributes requestAttributes = RequestContextHolder.getRequestAttributes();
            if (null != requestAttributes && requestAttributes.getClass().isAssignableFrom(ServletRequestAttributes.class)) {
                charsetEncodingName=((ServletRequestAttributes) requestAttributes).getRequest().getCharacterEncoding();
            }
        }catch (Exception  exp){
            //ignore
        }
        if(null!=charsetEncodingName&& !charsetEncodingName.isEmpty()){
            try {
                charSet = Charset.forName(charsetEncodingName);
            }catch (Exception   exp){
                //ignore
            }
        }
        String decodeMsgSign = URLDecoder.decode(msg_signature, charSet);
        String decodeTimestamp = URLDecoder.decode(timestamp, charSet);
        String decodeNonce = URLDecoder.decode(nonce, charSet);
        String decodeEchoStr = URLDecoder.decode(echostr, charSet);

        log.info("待验证信息:msg_signature={},timestamp={},nonce={},echostr={}",
                decodeMsgSign,
                decodeTimestamp,
                decodeNonce,
                decodeEchoStr
                );

        BusinessVerifyProperties businessVerifyProperties= SpringBeanHelper.getBean(BusinessVerifyProperties.class);
        WXBizMsgCrypt wxBizMsgCrypt = new WXBizMsgCrypt(businessVerifyProperties.getToken(),
                businessVerifyProperties.getEncodingAesKey(), businessVerifyProperties.getReceiveid());

        sEchoStr=wxBizMsgCrypt.VerifyURL(decodeMsgSign,decodeTimestamp,decodeNonce,decodeEchoStr);

        return sEchoStr;
    }
}
