package cn.jx.wechat.app.wechatrobot.util;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

/**
 * <p>spring上下文工具类</p>
 * @author gy
 */
@Component
public class SpringBeanHelper implements ApplicationContextAware {

	/**
	 * 上下文对象实例
	 */
	private static ApplicationContext applicationContext;

	@Override
	public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
		SpringBeanHelper.applicationContext = applicationContext;
	}


	public static ApplicationContext applicationContext() {
		return applicationContext;
	}



	public static Object getBean(String name) {
		return applicationContext().getBean(name);
	}


	public static <T> T getBean(Class<T> clazz) {
		return applicationContext().getBean(clazz);
	}


	public static <T> T getBean(String name, Class<T> clazz) {
		return applicationContext().getBean(name, clazz);
	}
}
