package cn.jx.wechat.app.wechatrobot.web.business;

import cn.jx.wechat.app.wechatrobot.service.face.BusinessVerify;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RequestMapping("/app/business/entry")
@RestController("appEntryCtrl")
public class AppEntryCtrl {

    private static Logger log= LoggerFactory.getLogger(AppEntryCtrl.class);

    private  BusinessVerify  businessVerify;
    @Autowired
    public AppEntryCtrl(BusinessVerify businessVerify){
        this.businessVerify = businessVerify;
    }

    @GetMapping
    public String businessGetCheck(@RequestParam String msg_signature, @RequestParam String timestamp,
                                @RequestParam String nonce, @RequestParam String echostr) {
        try {
           return businessVerify.businessCheck(msg_signature, timestamp, nonce, echostr);
        }catch (Exception e){
                log.info("企业微信API消息GET验证失败,{}",e.getMessage());
        }
        return String.format("%s","");
    }

    @PostMapping
    public  String  businessPostCheck(@RequestParam String msg_signature,@RequestParam String timestamp,
                                  @RequestParam  String nonce,@RequestParam String echostr){
        return businessVerify.businessCheck(msg_signature,timestamp,nonce,echostr);
    }


}
